%%This code solves a simple reform in which we set the capital taxes equal and
%let them adjust to balance the SS budget. One can also fix one of the taus.

%clc
clear all
warning off all

tic;
global nA A a m alpha eta omega rho nu k0 ds de lu ls rs re tauke tauks ks ke taul nY sigma Yu Ys asprime auprime ...
    lambdas lambdau lambdasa lambdaua x pis piu Ts Tu Amat Tlambdau Tlambdas tauc lambdal lspol lupol lsinv luinv  cspol cupol B betas omega nu betau meany G phi
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sigma = 2; %CRRA in consumption
gamma = 1; %power disutility of labor
taul = 0.18; %progressivity tax parameter in HSV


%technology
eta = .401; %KORV
%eta = .79;
rho = -.495;%KORV
%rho = -1;
%rho = eta
alpha = .117; %KORV
de = .124;%GHK
ds = .056;%GHK

%taxes
tauc = 0.05;

amin = 0;
amax = 10;
%A = linspace(amin, amax, 201)'
%controlling the density of grid points close to 0
A = ((exp(linspace(0,log(exp(2)*amax+1), 101)) - 1)/exp(2))';
nA=length(A);

%total measure of agents of each type calibrated from Census
pis = .778/(1+.778);
pis = 0.3169;
piu = 1-pis;

%transition matrix for skills from Krueger-Ludwig
perss = .969;
persu = .928;

scaling = 1;
%scaling = 4.455;%this hits the varlog of .45, which is the RED value
%scaling = 0.75;
vars = .01*scaling;
varu = .0192*scaling;

nY = 4;


%rouwenhorst
rouw = rouwenhorst(perss, vars^.5, nY);
Ys = exp(rouw(1,:));
Ts = rouw(2:nY+1, :);
rouw = rouwenhorst(persu, varu^.5, nY);
Yu = exp(rouw(1,:));
Tu = rouw(2:nY+1, :);

%rescaling so that means = 1
options.disp = 0;
[vector value] = eigs(Ts',1,1.1, options);
pisSS = vector(:,1)/sum(vector(:,1))';
[vector value] = eigs(Tu',1,1.1, options);
piuSS = vector(:,1)/sum(vector(:,1))';
meanS = Ys*pisSS;
meanU = Yu*piuSS;
Ys = Ys/meanS;
Yu = Yu/meanU;
cdfs = cumsum(pisSS);
cdfu = cumsum(piuSS);
Tscdf = cumsum(Ts,2);
Tucdf = cumsum(Tu,2);
Amat = kron(A, ones(1,nY));

%check properties of the processes
simulation = 0;
if simulation ==1;
simuln = 10000;


 %cdfs = cdfu;
 %Tscdf = Tucdf;
random(1) = unifrnd(0,1);
if random(1) < cdfs(1)
    Ysreal(1) = log(Ys(1));
    seps(1) = 1;
else
    for i = 2:nY
        if random(1) >= cdfs(i-1) & random(1)<cdfs(i)
           Ysreal(1) = log(Ys(i));
           seps(1) = i;
        end
    end
end

for j = 2: simuln
    
    random(j) = unifrnd(0,1);

    if random(j) <Tscdf(seps(j-1),1)
       Ysreal(j) = log(Ys(1));
       seps(j) = 1;
    else
        for i = 2:nY
            if random(j) >= Tscdf(seps(j-1), i-1) & random(j)<Tscdf(seps(j-1),i)
                Ysreal(j) = log(Ys(i));
                seps(j) = i;
            end
        end 
    end
end
%plot(Ysreal)
Ysreal = Ysreal';
seps;

 temprho = regress(Ysreal(2:simuln), [ones(simuln-1,1), Ysreal(1:simuln-1)])
 tempres = Ysreal(2:simuln)- temprho(1)*ones(simuln-1,1) - temprho(2)*Ysreal(1:simuln-1);
 (std(tempres))^2

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%initial guesses
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%loading prices etc.
    load inputnl
    out = inputnl;
    
    rs = out(1);
    r = rs;
    %re = (1-tauks)*(rs - ds)/(1-tauke) + de;%the NAC
    w = out(2:3);
    lambdal = out(4); %the constant in HSV tax function,
    B = out(5);
    betas = out(6);
    omega = out(7);
    nu = out(8);
    betau = out(9);
    meany = out(10);
    G = out(11);
    phi = out(12);
    
    load asprime.mat
    load auprime.mat
    load lspol.mat
    load lupol.mat
    load lsinv.mat
    load luinv.mat
    load z.mat

    tauks = .33;

%z0 =  [r, w, tauks]
z0 = z;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%loop in labor income to get consistency between exo and endo labor
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
diffl = 1;
xl = 1;
norml = 10^-7;

while (diffl > norml) & (xl <1000) %iteration on labor income
%while (xl < 50) %iteration on labor income
tic;
options = optimset('display', 'iter', 'tolfun', 10^(-20), 'tolX', 10^(-20), 'maxfunevals', 1000000, 'maxiter', 20); 
%options = optimset('display', 'iter', 'tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 100, 'NonlEqnAlgorithm', 'gn'); 
%options = optimset('display', 'iter', 'tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 100, 'NonlEqnAlgorithm', 'lm'); 
%options = optimset('display', 'iter', 'tolfun', 10^(-20), 'tolX', 10^(-20), 'maxfunevals', 1000000, 'maxiter', 30, 'largescale', 'on'); 

z = fsolve(@aiyagariref3, z0, options);
z0 = z;
%else
%aiyagariref3(z0)
%z = z0;
%end
toc;

rs = z(1);
r = rs;
w = z(2:3);
tauk = z(4);
tauks = tauk;
tauke = tauk;
re = (1-tauks)*(rs - ds)/(1-tauke) + de;%the NAC

z;

%stationary distribution
lambdasmat = (reshape(lambdas, nY, nA))';
lambdaumat = (reshape(lambdau, nY, nA))';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%constructing labor policies that would be consistent with consumption
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%computing consumption policies
%these are input into the intra FOC

Ysprime = lambdal*(kron(Ys*w(2), ones(nA,1)).*lspol/meany).^(-taul).*kron(Ys*w(2), ones(nA,1))*(1-taul);
Yuprime = lambdal*(kron(Yu*w(1), ones(nA,1)).*lspol/meany).^(-taul).*kron(Yu*w(1), ones(nA,1))*(1-taul);

lspolnew = (Ysprime./(phi*(1+tauc)*cspol.^sigma)).^(1/gamma);
lupolnew = (Yuprime./(phi*(1+tauc)*cupol.^sigma)).^(1/gamma);

diffl = sum(sum(lambdasmat.*abs(lspolnew - lspol))) + sum(sum(lambdaumat.*abs(lupolnew - lupol)))
if diffl > norml
        %setting the polices for next round
    polcoeff = 0.5;
    lspol = polcoeff*lspolnew+(1-polcoeff)*lspol;
    lupol = polcoeff*lupolnew+(1-polcoeff)*lupol;

   %Constructing l(a') to be consistent with both the new l(a,z) and a'(a,z)
    for k = 1:nA
        for m = 1:nY
           lsinvnew(k,m) = interp1(asprime(:, m), lspol(:,m), A(k),'linear','extrap'); %not ignoring the BC, but can have only 1 guy on it
           luinvnew(k,m) = interp1(auprime(:, m), lupol(:,m), A(k),'linear','extrap'); %not ignoring the BC, but can have only 1 guy on it
           
           %linv(k,m) = interp1(aprimeraw(:, m), lpol(:,m), A(k),'linear','extrap'); %ignoring the BC
           %linv(k,m) = interp1(aprime(:, m), lpol(:,m), A(k), 'linear','extrap'); 
           %using linear interpolation in Matlab, doesn't work with binding BC
           %linv(k,m) = interp1(A, lpol(:,m), ainv(k,m), 'linear', 'extrap'); %alternative mapping between l(a,z) and a'(a,z)
        end
    end


lsinv = lsinvnew;
luinv = luinvnew;

saving = 0;
if saving == 1;
    save asprime.mat asprime
    save auprime.mat auprime
    save lspol.mat lspol
    save lupol.mat lupol
    save lsinv.mat lsinv
    save luinv.mat luinv
    save z.mat z
end

end

xl = xl + 1;
end

%aggregate effective labors
ls = sum(sum(kron(Ys, ones(nA,1)).*lambdasmat.*lspol));
lu = sum(sum(kron(Yu, ones(nA,1)).*lambdaumat.*lupol));

%average labor
l1 = sum(sum(lambdasmat.*lspol))/pis;
l2 = sum(sum(lambdaumat.*lupol))/piu;
lagg = pis*l1+piu*l2;
%lagg = sum(sum(lambdasmat.*lspol)) + sum(sum(lambdaumat.*lupol));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%checking feasibility and a few other things
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%cdf
lambdasmatcdf = cumsum(lambdasmat,1);
lambdaumatcdf = cumsum(lambdaumat,1);
lambdasacdf = cumsum(lambdasa);
lambdauacdf = cumsum(lambdaua);

c1 = sum(sum(lambdasmat.*cspol))/pis;
c2 = sum(sum(lambdaumat.*cupol))/piu;
cagg = sum(sum(lambdasmat.*cspol)) + sum(sum(lambdaumat.*cupol));
iagg = de*ke + ds*ks;


gdp = ycomp(x);
gdpnet = gdp - ds*ks - de*ke;
check1 = gdp - lu*w(1) - ls*w(2) - rs*ks - re*ke;
check2 = gdp-cagg - de*ke - ds*ks - G;

MP = ycompprime2(x);
w = [MP(3), MP(4)];

lagg;
sp = w(2)/w(1); %if the mean is 1 in both sectors - should weight by hours?
KtoY = (ke+ks)/gdp;
lshare = (lu*w(1) + ls*w(2))/gdp;

NFAP = lambdasa'*A + lambdaua'*A - B - (ks+ke);
%domestic asset holdings
assets = lambdasa'*A + lambdaua'*A;

%pre tax earnings
ears = kron(Ys.*w(2),ones(nA,1)).*lspol;
earu = kron(Yu.*w(1),ones(nA,1)).*lupol;
aears = sum(sum(lambdasmat.*ears))/pis;
aearu = sum(sum(lambdaumat.*earu))/piu;
%aear = aears*pis + aearu*piu; %should be equal to meany

%aftertax earnings
Ysmat = lambdal*(kron(Ys*w(2), ones(nA,1)).*lspol/meany).^(1-taul)*meany;
Yumat = lambdal*(kron(Yu*w(1), ones(nA,1)).*lupol/meany).^(1-taul)*meany;

%average taxes
ats  = (ears-Ysmat)./ears;
atu  = (earu-Yumat)./earu;
ats = sum(sum(lambdasmat.*ats))/pis;
atu = sum(sum(lambdaumat.*atu))/piu;
atagg = ats*pis + atu*piu;

%total pre-tax income 
incomes = ears + (rs-ds)*Amat;
incomeu = earu + (rs-ds)*Amat;

%tax revenues
ltax = sum(sum((ears-Ysmat).*lambdasmat +(earu-Yumat).*lambdaumat));

ctax = (MP(1) - ds)*ks*tauks +  (MP(2) - de)*ke*tauke;
corptax = ((1-(1-tauks)/.85)*(MP(1) - ds)*ks + (1-(1-tauke)/.85)*(MP(2) - de)*ke);
%tax rates faced by the firms for consistency
taufe = 1-(1-tauke)/.85;
taufs = 1-(1-tauks)/.85;
cctax = ((1-taufs)*(MP(1) - ds)*ks + (1-taufe)*(MP(2) - de)*ke)*.15;

%compute relative capital holdings - how do KL (2013) do on this?
rks = lambdasa'*A/pis/(lambdaua'*A/piu);

%finding the asset gini
 lambdaa = lambdaua + lambdasa;
 asset = A.*lambdaa;
 si = cumsum(asset,1);
 siminus = [0; si(1:nA-1)];
 Giniasset = 1 - (lambdaa'*(si+siminus))/si(nA);
  %variance of log assets
 meanasset = log(A(2:length(A)))'*lambdaa(2:length(A));
 varlogasset = ((log(A(2:length(A)))-meanasset).^2)'*lambdaa(2:length(A));
 
% 
% %finding the asset quintiles
 lambdaacdf = lambdauacdf + lambdasacdf;
 quint = lambdaacdf*ones(1,4) - kron([.5,.9,.95,.99], ones(nA,1));
 quint = quint < 0;
 %(A*ones(1,4)).*quint.*(lambdaa*ones(1,4));
 quintiles = [sum((A*ones(1,4)).*quint.*(lambdaa*ones(1,4)))/si(nA),1];
 quintiles = quintiles - [0, quintiles(1:4)];
% 
% %finding the pre-tex labor earnings gini
 earprob = [[reshape(ears', nA*nY,1);reshape(earu', nA*nY,1)], [lambdas; lambdau]];
 %variance of log earnings
 meanear = log(earprob(:,1))'*earprob(:,2);
 varlogear = ((log(earprob(:,1))-meanear).^2)'*earprob(:,2);
 
 earprobsort = sortrows(earprob,1);
 earning = earprobsort(:,1).*earprobsort(:,2);
 si = cumsum(earning,1);
 probcdf = cumsum(earprobsort(:,2));
 %plot(probcdf, si);
 siminus = [0; si(1:2*nY*nA-1)];
 Gini = 1 - (earprobsort(:,2)'*(si+siminus))/si(2*nY*nA);
 
 %finding the within group earnings varlog and gini 
 earprobs = [reshape(ears', nA*nY,1), lambdas/pis];
 earprobu = [reshape(earu', nA*nY,1) lambdau/piu];
 %variance of log earnings
 meanears = log(earprobs(:,1))'*earprobs(:,2);
 meanearu = log(earprobu(:,1))'*earprobu(:,2);
 varlogears = ((log(earprobs(:,1))-meanears).^2)'*earprobs(:,2);
 varlogearu = ((log(earprobu(:,1))-meanearu).^2)'*earprobu(:,2);
 
 earprobsorts = sortrows(earprobs,1);
 earnings = earprobsorts(:,1).*earprobsorts(:,2);
 sis = cumsum(earnings,1);
 probcdfs = cumsum(earprobsorts(:,2));
 siminuss = [0; sis(1:nY*nA-1)];
 Ginis = 1 - (earprobsorts(:,2)'*(sis+siminuss))/sis(nY*nA);
 
 earprobsortu = sortrows(earprobu,1);
 earningu = earprobsortu(:,1).*earprobsortu(:,2);
 siu = cumsum(earningu,1);
 probcdfu = cumsum(earprobsortu(:,2));
 siminusu = [0; siu(1:nY*nA-1)];
 Giniu = 1 - (earprobsortu(:,2)'*(siu+siminusu))/siu(nY*nA);
 
%finding the earnings quintiles SHOULD TAKE INTO ACCOUNT DISCRETE JUMPS
 quintear = probcdf*ones(1,4) - kron([.5, .9,.95,.99], ones(nA*nY*2,1));
 quintear = quintear < 0;
 quintilesear = [sum((earprobsort(:,1)*ones(1,4)).*quintear.*(earprobsort(:,2)*ones(1,4)))/si(nA*nY*2),1];
 quintilesear = quintilesear - [0, quintilesear(1:4)];
 %90-10 ratio
 ninetyten = max(quintear(:,4).*earprobsort(:,1))/max(quintear(:,1).*earprobsort(:,1));

%computing earnings-asset correlations

%finding the (raw) wage gini
 wprob = [[w(2)*Ys';w(1)*Yu'],[pis*pisSS;piu*piuSS]];
 wprobsort = sortrows(wprob,1);
 wage = wprobsort(:,1).*wprobsort(:,2);
 si = cumsum(wage,1);
 probcdf = cumsum(wprobsort(:,2));
 %plot(probcdf, si);
 siminus = [0; si(1:2*nY-1)];
 Giniw = 1 - (wprobsort(:,2)'*(si+siminus))/si(2*nY);
 %finding the varlog
logw = log(wprob(:,1));
meanlogw = logw'*wprob(:,2);
varlogw = wprob(:,2)'*(logw-meanlogw).^2;


 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%recover the values
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%u not needed anywhere else, make sure to use the right parameters
if sigma == 1
   u  = @(c) log(c);
   up = @(c) 1./c;
else
    u  = @(c) c.^(1-sigma)./(1-sigma);
    up = @(c) c.^-sigma;
end

v  = @(l) phi*l.^(1+gamma)./(1+gamma);
vp = @(l) phi*l.^gamma;

valuerec = 1;%handle to recover the value function, not needed!
if valuerec ==1;

VsSS2 = zeros(nA, nY);
VuSS2 = zeros(nA, nY);  

load VsSS2 VsSS2
load VuSS2 VuSS2

diffv = 1;
xv = 0;
normv = 10^-10;
tic
while diffv > normv

    for k = 1:nA
        for m = 1:nY
                TVs(k,m) = u(cspol(k,m)) - v(lspol(k,m)) + betas*Ts(m,:)*(interp1(A, VsSS2, asprime(k,m),'linear','extrap'))';
                TVu(k,m) = u(cupol(k,m)) - v(lupol(k,m)) + betau*Tu(m,:)*(interp1(A, VuSS2, auprime(k,m),'linear','extrap'))';
         end
    end
    diffv = sum(sum(abs(VsSS2-TVs))) + sum(sum(abs(VuSS2-TVu)));
    VsSS2 = TVs;
    VuSS2 = TVu;
    xv = xv+1;
end
   diffv;
toc

save VsSS2 VsSS2
save VuSS2 VuSS2

Vmeansalt = sum(sum(VsSS2.*lambdasmat));
Vmeanualt = sum(sum(VuSS2.*lambdaumat));

end
umeans = sum(sum(lambdasmat.*u(cspol)))/(1-betas);
umeanu = sum(sum(lambdaumat.*u(cupol)))/(1-betau);
vmeans = sum(sum(lambdasmat.*v(lspol)))/(1-betas);
vmeanu = sum(sum(lambdaumat.*v(lupol)))/(1-betau);

Vmeans = umeans - vmeans;
Vmeanu = umeanu - vmeanu;
Vmean = Vmeans + Vmeanu;

output = [pis, sigma, gamma, phi, omega, nu,  betas, betau, lambdal, meany, G, B, umeans, umeanu, vmeans, vmeanu, Vmeans, Vmeanu, Vmean, tauks, tauke, ctax, corptax, ...
    cctax, taul, ltax, ats atu, tauc, gdp, G/gdp, B/gdp, ks, ke,  ke+ks, ke/(ke+ks), (ke+ks)/gdp, assets ...
     cagg, iagg, c1, c2, lagg, l1, l2, w(1), w(2), w(2)/w(1) (lu*w(1) + ls*w(2))/gdp, rks, rs, re, (rs-ds)*(1-tauks), (re-de)*(1-tauke) ...
      (rs-ds), (re-de), ((rs-ds)*ks + (re-de)*ke)/(ks+ke), varlogw, Giniw, varlogear, Gini, varlogears,  Ginis, varlogearu, Giniu, quintilesear, Giniasset, quintiles]';


%for transition computations
qs = 1;
xSS2 = [x, lambdal, gdp, 1+(rs-qs*ds)*(1-tauks)/qs, B/gdp];
save('SS2', 'xSS2', 'asprime', 'auprime', 'lspol', 'lupol', 'lsinv', 'luinv', 'lambdas', 'lambdau')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figures
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figures = 0;
if figures  == 1
figure(1)
plot(A, lambdasmat, 'r');
hold on;
plot(A, lambdaumat, 'b');
% hold on;
% plot(A, lambdasa, 'r');
% hold on;
% plot(A, lambdaua, 'b');
title('pdfs')

 figure(2)
 plot(A, cspol, 'r');
 hold on;
 plot(A, cupol, 'b');
 title('consumption')

 figure(3)
 plot(A, lspol, 'r');
 hold on;
 plot(A, lupol, 'b');
 title('labor')
% 
figure(4)
plot(A, lambdasmatcdf, 'r');
hold on;
plot(A, lambdaumatcdf, 'b');
title('cdfs')
% 
figure(5)
plot(A, ears, 'r');
hold on;
plot(A, earu, 'b');
title('pre-tax earnings')

 figure(6)
 plot(A, asprime, 'r');
 hold on;
 plot(A, auprime, 'b');
 hold on;
 plot(A,A, 'k');
 title('assets')

% figure(4)
% plot(A, fes, 'r');
% hold on;
% plot(A, feu, 'b');
% title('frisch elasticity')
 
% figure(6)
% plot(A, V(:,1), 'r');
% hold on;
% plot(A, V(:,2), 'b');
% 

end